/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2004 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Description : Encoder internal
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: EncProfile.h,v $
--  $Date: 2005/08/12 10:47:29 $
--  $Revision: 1.6 $
--
------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------

    Table of context

    1. Include headers
    2. External compiler flags
    3. Module defines
    4. Function prototypes

------------------------------------------------------------------------------*/
#ifndef __ENC_PROFILE_
#define __ENC_PROFILE__

/*------------------------------------------------------------------------------
    1. Include headers
------------------------------------------------------------------------------*/
#include "basetype.h"
#include "EncSim.h"

/*------------------------------------------------------------------------------
    2. External compiler flags
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
    3. Module defines
------------------------------------------------------------------------------*/
typedef struct {
	i32	width;		/* Width of image rounded next mb boundary */
	i32	height;		/* Height of image rounded next mb boundary */
	i32	bitPerSecond;	/* Input bit rate per second */
	i32	vopTimeIncRes;	/* Input frame rate numerator */
	i32	timeInc;	/* Input frame rate denominator */
	i32	vpSize;		/* Video packet size */
	true_e	dataPart;	/* Data partition */
	i32	mvRange;	/* 0 -> mv range [-16 15], 1 -> mv [-32 31] */
	i32	intraDcVlcThr;	/* Table 6-21 */
	true_e	mbRc;		/* Mb header qp can vary, check point rc */
	true_e	acPred;		/* YES/NO */
	i32	profile;	/* Profile and level (Table G-1) */
	i32	videoBufferSize;/* Rate control need this */
	i32	videoBufferBitCnt;
	i32	mbPerVopMax;	/* Profile limitation of macroblocks per vop */
	i32	vpSizeMax;	/* Profile limitation of vp size */
	i32	bitPerSecondMax;/* Profile limitatiion of bitrate */
} profile_s;

/*------------------------------------------------------------------------------
    4. Function prototypes
------------------------------------------------------------------------------*/
bool_e EncInitProfile(profile_s *profile);
bool_e EncProfileCheck(profile_s *profile);

#endif

