/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2004 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Description : Encoder internal
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: EncShortVideoHeader.h,v $
--  $Date: 2005/11/03 14:32:38 $
--  $Revision: 1.8 $
--
------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------

    Table of context

    1. Include headers
    2. External compiler flags
    3. Module defines
    4. Function prototypes

------------------------------------------------------------------------------*/
#ifndef __ENC_SHORT_VIDEO_HEADER_H__
#define __ENC_SHORT_VIDEO_HEADER_H__

/*------------------------------------------------------------------------------
    1. Include headers
------------------------------------------------------------------------------*/
#include "basetype.h"
#include "EncSim.h"
#include "EncVideoObjectPlane.h"
#include "EncPutBits.h"

/*------------------------------------------------------------------------------
    2. External compiler flags
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
    3. Module defines
------------------------------------------------------------------------------*/
typedef struct {
	true_e	header;			/* YES/NO */
	vopType_e vopType;		/* Table 6-20 */
	i32	tempRef;
	i32	splitScreenIndicator;
	i32	documentCameraIndicator;
	i32	fullPictureFreezeRelease;
	i32	sourceFormat;		/* Table 6-25 */
	i32	gobPlace;		/* Define place of gob */
	i32	mbInGob;		/* Total number of macroblocks in GOB */
	i32	gobNum;			/* GOB number */
	i32	gobFrameId;		/* Some fields has been changed */
	i32	gobFrameIdBit;		/* GobFrameId bit field */
	i32	timeCode;		/* TimeCode remainder */

	true_e	plusHeader;		/* YES/NO */
	i32	roundControl;		/* 1/0 */
	i32	videoObjectLayerWidth;	/* vol->videoObjectLayerWidth */
	i32	videoObjectLayerHeight;	/* vol->videoObjectLayerHeight */
	i32	pwi;			/* Pixel per line (pwi+1)*4 */
	i32	phi;			/* Numer of lines phi*4 */
	i32	ufepTempRef;		/* Last UFEP="001" time cnt */
	i32	ufepTempRefPrev;	/* Previous value of svh->tempRef */
	i32	ufepCnt;		/* Last UFEP="001" vop cnt */
} svh_s;

/*------------------------------------------------------------------------------
    4. Function prototypes
------------------------------------------------------------------------------*/
void EncSvhInit(svh_s *);
void EncSvhHdr(stream_s *, svh_s *, i32 qp);
void EncGobHdr(stream_s *, svh_s *, i32);
bool_e EncSvhCheck(svh_s *);
u32 EncGobFrameId(svh_s * svh);

#endif
