/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2004 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Description : Encoder internal
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: EncVideoObjectPlane.h,v $
--  $Date: 2005/11/03 14:32:39 $
--  $Revision: 1.7 $
--
------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------

    Table of context

    1. Include headers
    2. External compiler flags
    3. Module defines
    4. Function prototypes

------------------------------------------------------------------------------*/
#ifndef __ENC_VIDEO_OBJECT_PLANE_H__
#define __ENC_VIDEO_OBJECT_PLANE_H__

/*------------------------------------------------------------------------------
    1. Include headers
------------------------------------------------------------------------------*/
#include "basetype.h"
#include "EncSim.h"
#include "EncPutBits.h"

/*------------------------------------------------------------------------------
    2. External compiler flags
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
    3. Module defines
------------------------------------------------------------------------------*/
/* vopType (Table 6-20) */
typedef enum {
	IVOP = 0,
	PVOP = 1,
	BVOP = 2,
	SVOP = 3
} vopType_e;

/* Video Object Plane */
typedef struct {
	true_e	header;			/* YES/NO */
	true_e	vopCoded;		/* YES/NO */
	true_e	hec;			/* YES/NO */
	true_e	acPred;			/* YES/NO */
	vopType_e vopType;		/* Table 6-20 */
	i32	roundControl;		/* 1/0 */
	i32	intraDcVlcThr;		/* Table 6-21 */
	i32	vopFcodeForward;	/* Table 7-5 */
	i32	vopTimeInc;		/* 1-16 bit */
	i32	moduloTimeBase;		/* Seconds elapsed since last ref */
	i32	vopTimeIncRes;		/* Input frame rate numerator */
} vop_s;

/*------------------------------------------------------------------------------
    4. Function prototypes
------------------------------------------------------------------------------*/
void EncVopInit(vop_s *vop);
void EncVopHdr(stream_s *, vop_s *, i32);

#endif
