/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2003 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Abstract : All the encoder's internal data container def
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: enccontainer.h,v $
--  $Date: 2005/11/03 14:21:46 $
--  $Revision: 1.13 $
--
------------------------------------------------------------------------------*/

#ifndef __ENCCONTAINER_H__
#define __ENCCONTAINER_H__

#include "basetype.h"

#include "EncInstance.h"

typedef struct EncAsicData
{
    u32 *pLumRefImg;
    u32 *pChromRefImg1;
    u32 *pChromRefImg2;
    u32 *pVpSizeBuf;
    u32 *pMbBuf2;
    u32 *pDctBuf3;
    u32 MbBuf2Size;
    u32 DctBuf3Size;
    u32 chromaRef;
    u32 width_mb;
    u32 height_mb;
    /* User configurable parameters */
    u32 imgEndianess;
    u32 strmEndianess;
    u32 fourMV;
    u32 outsideVopMv;
    u32 intraSadPenalty;
    u32 mvSadPenalty;
    u32 fourMvSadPenalty;
}
EncAsicData_t;

typedef struct EncContainer
{
    instance_s inst;
    EncAsicData_t asic;
    u32 encStatus;
    u32 vopBytes;
    timeCode_s timeCodePrev; 
}
EncContainer_t;

#endif /*__ENCCONTAINER_H__*/
