/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2003 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Abstract : Memory management
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: encmemory.h,v $
--  $Date: 2005/11/03 14:21:46 $
--  $Revision: 1.4 $
--
------------------------------------------------------------------------------*/

#ifndef __ENCMEMORY_H__
#define __ENCMEMORY_H__

#include "basetype.h"
#include "enccontainer.h"
#include <stdlib.h>
#include <string.h>

i32 AllocMem(EncContainer_t * pEncData);
void FreeMem(EncContainer_t * pEncData);

static __inline void *hantro_malloc(u32 n)
{
    return malloc(n);
}

static __inline void *hantro_calloc(u32 n, u32 s)
{
    return calloc(n, s);
}

static __inline void *hantro_memcpy(void *d, const void *s, u32 n)
{
    return memcpy(d, s, n);
}

static __inline void hantro_free(void *p)
{
    free(p);
}

#endif /* __ENCMEMORY_H__ */
