/*------------------------------------------------------------------------------
--                                                                            --
--       This software is confidential and proprietary and may be used        --
--        only as expressly authorized by a licensing agreement from          --
--                                                                            --
--                            Hantro Products Oy.                             --
--                                                                            --
--      In the event of publication, the following notice is applicable:      --
--                                                                            --
--                   (C) COPYRIGHT 2003 HANTRO PRODUCTS OY                    --
--                            ALL RIGHTS RESERVED                             --
--                                                                            --
--          The entire notice above must be reproduced on all copies.         --
--                                                                            --
--------------------------------------------------------------------------------
--
--  Project  : 1200s
--
--  Abstract : Encoder wrapper layer
--
--------------------------------------------------------------------------------
--
--  Version control information, please leave untouched.
--
--  $RCSfile: ewl.h,v $
--  $Author: user $
--  $Date: 2005/08/09 09:20:39 $
--  $Revision: 1.4 $
--  $Name: Rel5251-HW_Encoder_Control_Code_GLA-Linux_2_6-iMX31-src-1_1 $
--
------------------------------------------------------------------------------*/

#ifndef __EWL_H__
#define __EWL_H__

#include "basetype.h"

#undef PTRACE   /* undef it, just in case */
#if defined(TRACE_EWL)
#   define PTRACE(fmt, args...) printf(__FILE__ ":%d: " fmt, __LINE__ , ## args)
#elif defined(__GNUC__)
#   define PTRACE(fmt, args...) /* no trace */
#else
#   define PTRACE()
#endif

enum ewl_ret
{
    EWL_OK = 0,
    EWL_NOK = -1,
    EWL_TIMEOUT = 1
};

extern u32 EWL_ReadReg(u32 offset);
extern void EWL_WriteReg(u32 offset, u32 val);

extern i32 EWL_Init(void);
extern i32 EWL_Release(void);

extern u32 *EWL_MallocLinear(u32 size);
extern void EWL_FreeLinear(u32 * pVirt);
extern u32 EWL_Virt2Bus(u32 * pVirt);

extern i32 EWL_PostHwRdy(void);
extern i32 EWL_WaitHwRdy(void);
extern i32 EWL_ResetHwRdy(void);

#endif /*__EWL_H__*/
